//-----------------------------------------------------------------------------------------------
// Rotary_wemos
// ----------------------------------------------------------------------------------------------
#include "Rotary_wemos.h"

// Constructor: Define the two pins, and optinally swap direction
Rotary::Rotary(unsigned char EN1_Pin, unsigned char EN2_Pin, bool swap) {
  EN1 = (!swap) ? EN1_Pin : EN2_Pin;
  EN2 = (!swap) ? EN2_Pin : EN1_Pin;

  // Set both pins as input pins, with internal pullup  
  //pinMode(EN1, INPUT_PULLUP);
  //pinMode(EN2, INPUT_PULLUP);

  // Define default values
  A_Previous = digitalRead(EN1);
  B_Previous = digitalRead(EN2);
  
  rotary_Value = 0;
  rotary_Changed = false;
}

// Reset the rotary value to zero
void Rotary::Reset() {
  rotary_Value = 0;
}

// Check if the rotary value has changed
bool Rotary::Changed() {
	bool current = rotary_Changed;
	rotary_Changed = false;
	return current;
}

// Read the rotary value
int Rotary::Read() {
  A_Current = digitalRead(EN1);
  B_Current = digitalRead(EN2);
  rotary_Changed = false;
  
  if (A_Current != A_Previous) {
	  A_Previous = A_Current;
	  rotary_Changed = true;
    if (A_Current != B_Current) {
      rotary_Value++;
    } else {
      rotary_Value--;
    }
  }
  if (B_Current != B_Previous) {
    B_Previous = B_Current;
	  rotary_Changed = true;
    if (A_Current == B_Current) {
      rotary_Value++;
    } else {
      rotary_Value--;
    }
  }
  
  // Debouce: Add 50us delay between reads
  delayMicroseconds(50);
  return rotary_Value;  
}
